<h1 align="center">
IntervalRootFinding

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaintervals.github.io/IntervalRootFinding.jl/stable)
[![Stable](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliaintervals.github.io/IntervalRootFinding.jl/dev)
[![Build Status](https://github.com/JuliaIntervals/IntervalRootFinding.jl/workflows/CI/badge.svg)](https://github.com/JuliaIntervals/IntervalRootFinding.jl/actions/workflows/CI.yml)
[![coverage](https://codecov.io/gh/JuliaIntervals/IntervalRootFinding.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIntervals/IntervalRootFinding.jl)
</h1>

IntervalRootFinding.jl is a Julia package for finding the roots of functions, i.e. solutions to the equation $f(x) = 0$.
To do so, it uses interval arithmetic from the [IntervalArithmetic](https://github.com/JuliaIntervals/IntervalArithmetic.jl) library.

## Documentation

The official documentation is available online: https://juliaintervals.github.io/IntervalRootFinding.jl/stable.

## Installation

The IntervalRootFinding.jl package requires to [install Julia](https://julialang.org/downloads/).

Then, start Julia and execute the following command in the REPL:

```julia
using Pkg; Pkg.add("IntervalRootFinding")
```

## Basic usage examples

The basic function is `roots`. Given a standard Julia function and an interval, the `roots` function returns a list of intervals containing all roots of the function located in the prescribed interval.

```julia
julia> using IntervalArithmetic, IntervalRootFinding

julia> using IntervalArithmetic.Symbols  # to use `..`

julia> f(x) = sin(x) - 0.1*x^2 + 1
f (generic function with 1 method)

julia> roots(f, -10 .. 10)
4-element Vector{Root{Interval{Float64}}}:
 Root([-4.42654, -4.42653]_com_NG, :unique)
 Root([-3.10682, -3.10681]_com_NG, :unique)
 Root([-1.08205, -1.08204]_com_NG, :unique)
 Root([3.14959, 3.1496]_com_NG, :unique)
```

The `:unique` status indicates that each listed interval contains exactly one root. The other possible status is `:unknown`, which corresponds to intervals that may contain zero, one, or more roots (no guarantee is provided for these intervals).

These results are represented in the following plot, the region containing roots being in green.

![basic usage](docs/src/basic_usage.png)

function realify(f)
    function g(x)
        z2 = f(Complex(x...))
        return [z2.re, z2.im]
    end

    return g
end

"""
    realify_derivative(fp)

Takes the derivative of a complex function and returns the real jacobian
that implements it.
"""
function realify_derivative(fp)
    function g_jac(x)
        fpz = fp(Complex(x...))
        return [fpz.re -fpz.im ; fpz.im fpz.re]
    end
    return g_jac
end

include("../examples/smiley_examples.jl")

using .SmileyExample22, .SmileyExample52, .SmileyExample54, .SmileyExample55

const abstol = 1e-6

@testset "$(SmileyExample22.title)" begin
    for contractor in (Newton, Krawczyk)
        roots_found = roots(SmileyExample22.f, SmileyExample22.region ; contractor, abstol)
        @test length(roots_found) == 8
        @test all(isunique, roots_found)
        # no reference data for roots given
    end
end

@testset "$(example.title)" for example in (SmileyExample52, SmileyExample54)
    for contractor in (Newton, Krawczyk)
        roots_found = roots(example.f, example.region ; contractor, abstol)
        @test length(roots_found) == length(example.known_roots)
        @test all(isunique, roots_found)
        for rf in roots_found
            # check there is exactly one known root for each found root
            @test 1 == sum(example.known_roots) do rk
                !isempty_region(intersect_region(rk, root_region(rf)))
            end
        end
    end
end

in_region(x, Y::Interval) = in_interval(x, Y)
in_region(x::AbstractVector, Y::AbstractVector{<:Interval}) = all(in_interval.(x, Y))

function intersect_region(X::Interval, Y::Interval)
    dec = min(decoration(X), decoration(Y))
    return IntervalArithmetic.setdecoration(intersect_interval(X, Y), dec)
end

intersect_region(X::AbstractVector, Y::AbstractVector) = intersect_region.(X, Y)

isempty_region(X::Interval) = isempty_interval(X)
isempty_region(X::AbstractVector) = any(isempty_region, X)

isequal_region(X::Interval, Y::Interval) = isequal_interval(X, Y)
isequal_region(X::AbstractVector, Y::AbstractVector) = all(XY -> isequal_region(XY...), zip(X, Y))

isbounded_region(X::Interval) = isbounded(X)
isbounded_region(X::AbstractVector) = all(isbounded, X)

isnai_region(X::Interval) = isnai(X)
isnai_region(X::AbstractVector) = any(isnai, X)

diam_region(X::Interval) = diam(X)
diam_region(X::AbstractVector) = maximum(diam, X)

mag_region(X::Interval) = mag(X)
mag_region(X::AbstractVector) = maximum(mag, X)

mig_region(X::Interval) = mig(X)
mig_region(X::AbstractVector) = minimum(mig, X)

bisect_region(X::Interval, α) = bisect(X, α)

function bisect_region(X::AbstractVector, α)
    X1 = copy(X)
    X2 = copy(X)

    i = argmax(diam.(X))
    x1, x2 = bisect_region(X[i], α)
    X1[i] = x1
    X2[i] = x2
    return X1, X2
end

function bisect_region(X::SVector{N, T}, α) where {N, T}
    i = argmax(diam.(X))
    x1, x2 = bisect_region(X[i], α)
    X1 = SVector{N, T}(k == i ? x1 : X[k] for k in 1:N)
    X2 = SVector{N, T}(k == i ? x2 : X[k] for k in 1:N)
    return X1, X2
end

istrivial(X::Interval) = decoration(X) <= trv
istrivial(X::AbstractVector) = any(istrivial, X)

using IntervalArithmetic
using IntervalRootFinding

f(x) = sin(1/(x + 0.5))

## Stop when the first (guaranteed) root is found
pb = RootProblem(f, interval(-10, 10))
state = nothing

for s in pb
    global state = s  # Needed to access the state outside of the loop later
    # `roots(state)` return a list of all roots actually considered
    # Here as soon as one has the :unique status in one of the iteration,
    # we stop the search
    any(isunique, roots(state)) && break
end

# Show the state of the search at the end of the iterations
# Use `roots(state)` to get the list of roots
println(state)

## Choose the order of processing manually
# The `ChangingOrder` search order allows to choose which region
# is processed next at each iteration
pb = RootProblem(f, interval(-10, 10) ; search_order = ChangingOrder)
state = nothing

for s in pb
    global state = s
    any(isunique, roots(state)) && break
    # `unconverged_roots(state)` return the set of roots that have not yet been finalized
    # We need to choose one of them to be processed at the next iteration
    rts = unconverged_roots(state)
    # `mig` return the smallest distance from a member of the interval to zero
    # Therefore the minimal value of `mig` corresponds to the interval closest to zero
    next = argmin(mig.(rts))
    # Use the index to set the next region that should be processed
    set_next!(state.search_order, next)
end

# Show the state of the search at the end of the iterations
# We can see that there are no unprocessed region closest to zero than the found root!
println(state)

# Note that `ChangingOrder` is not optimized,
# defining a new `SearchOrder` may be better in some case

"""
    quadratic_helper!(a::Interval, b::Interval, c::Interval, L::Array{Interval})

Helper function for `quadratic_interval` that computes roots of a
real quadratic using interval arithmetic to bound rounding errors.
"""
function quadratic_helper!(a::Interval{T}, b::Interval{T}, c::Interval{T}, L::Array{Interval{T}}) where {T}

    Δ = b^2 - 4*a*c

    Δ.hi < 0 && return

    Δ = sqrt(Δ)

    if (b.lo >= 0)
        x0 = -0.5 * (b + Δ)

    else
        x0 = -0.5 * (b - Δ)
    end

    if (0 ∈ x0)
        push!(L, x0)

    else
        x1 = c / x0
        x0 = x0 / a
        push!(L, x0, x1)
    end

end


"""
    quadratic_roots(a::Interval, b::Interval, c::Interval)

Function to solve a quadratic equation where the coefficients are intervals.
Returns an array of intervals of the roots.
Arguments `a`, `b` and `c` are interval coefficients of `x²`, `x` and `1` respectively.
The interval case differs from the non-interval case in that
there might be three disjoint interval roots. In the third
case, one interval root extends to −∞ and another extends to +∞.
This algorithm finds the set of points where `F.lo(x) ≥ 0` and the set
of points where `F.hi(x) ≤ 0` and takes the intersection of these two sets.

Reference: [Hansen and Walster (2003), Chapter 8](@cite hansen2003)
"""
function quadratic_roots(a::Interval{T}, b::Interval{T}, c::Interval{T}) where {T}

    L = Interval{T}[]
    R = Interval{T}[]

    quadratic_helper!(Interval(a.lo), Interval(b.lo), Interval(c.lo), L)
    quadratic_helper!(Interval(a.hi), Interval(b.hi), Interval(c.hi), L)
    quadratic_helper!(Interval(a.lo), Interval(b.hi), Interval(c.lo), L)
    quadratic_helper!(Interval(a.hi), Interval(b.lo), Interval(c.hi), L)

    if (length(L) == 8)
        resize!(L, 4)
    end

    if (a.lo < 0 || (a.lo == 0 && b.hi == 0) || (a.lo == 0 && b.hi == 0 && c.lo ≤ 0))
        push!(L, Interval(-∞))
    end

    if (a.lo < 0 || (a.lo == 0 && b.lo == 0) || (a.lo == 0 && b.lo == 0 && c.lo ≤ 0))
        push!(L, Interval(∞))
    end

    sort!(L, by = x -> x.lo)

    for i in 1:2:length(L)
        push!(R, Interval(L[i].lo, L[i+1].hi))
    end

    R
end

function image_contains_zero(f, R::Root)
    X = root_region(R)
    R.status == :empty && return Root(X, :empty)

    imX = f(X)
    size(imX) != size(X) && throw(DimensionMismatch("input and output dimensions of f must be the same"))

    if !(all(in_interval.(0, imX))) || isempty_region(imX)
        return Root(X, :empty)
    end

    return Root(X, :unknown)
end

"""
    AbstractContractor

Abstract type for contractors.
"""
abstract type AbstractContractor end

struct Bisection <: AbstractContractor end
struct Newton <: AbstractContractor end
struct Krawczyk <: AbstractContractor end

function contract(::Type{Newton}, f, derivative, X::Interval)
    m = interval(mid(X))
    return m - (f(m) / derivative(X))
end

function contract(::Type{Newton}, f, derivative, X::AbstractVector)
    m = interval.(mid.(X))
    J = derivative(X)
    y = gauss_elimination_interval(J, f(m))  # J \ f(m)
    return m .- y
end

function contract(::Type{Krawczyk}, f, derivative, X::Interval)
    m = interval(mid(X))
    Y = inv(derivative(m))

    return m - Y*f(m) + (interval(1) - Y*derivative(X)) * (X - m)
end

function contract(::Type{Krawczyk}, f, derivative, X::AbstractVector)
    # We check the interval derivative first because if it works, we know that
    # the derivative of the center below works as well
    J = derivative(X)
    any(xx -> decoration(xx) == trv, J) && return interval(-Inf, Inf, trv)

    m = mid.(X)
    dm = derivative(m)
    det(dm) == 0 && return interval(-Inf, Inf, trv)

    Y = interval.(inv(dm))
    mm = interval.(m)

    return mm - Y*f(mm) + (interval(I) - Y*J) * (X - mm)
end

function contract(::Type{C}, f::F, derivative::Fp, R::Root) where {C <: AbstractContractor, F, Fp}
    # We first check with the simple bisection method
    # If we can prove it is empty at this point, we don't go further
    R2 = image_contains_zero(f, R)
    C == Bisection && return R2
    R2.status == :empty && return R2

    X = root_region(R)
    contracted_X = contract(C, f, derivative, X)
    istrivial(contracted_X) && return Root(X, :unknown)

    # Only happens if X is partially out of the domain of f
    isempty_region(contracted_X) && return Root(X, :unknown)  # force bisection

    NX = intersect_region(contracted_X, X)

    !isbounded_region(X) && return Root(NX, :unknown)  # force bisection
    isempty_region(NX) && return Root(X, :empty)

    if R.status == :unique || NX ⪽ X  # isstrictsubset_interval, we know there's a unique root inside
        return Root(NX, :unique)
    end

    return Root(NX, :unknown)
end

function contract(root_problem::RootProblem{C}, R::Root) where C
    return contract(C, root_problem.f, root_problem.derivative, R)
end

"""
    refine(root_problem::RootProblem, X::Root)

Refine a root.
"""
function refine(root_problem::RootProblem{C}, R::Root) where C
    root_status(R) != :unique && throw(ArgumentError("trying to refine a non unique root"))

    X = root_region(R)

    while diam_region(X) > root_problem.abstol
        contracted = contract(C, root_problem.f, root_problem.derivative, X)
        istrivial(contracted) && break  # no point going further
        NX = intersect_region(contracted, X)
        isequal_region(NX, X) && break  # reached limit of precision
        X = NX
    end

    return Root(X, :unique, :converged)
end

module IntervalRootFinding

using Reexport
@reexport using IntervalArithmetic
using IntervalArithmetic.Symbols

@reexport using BranchAndPrune
using ForwardDiff
using ForwardDiff: derivative, jacobian
using InteractiveUtils
using StaticArrays

using LinearAlgebra

import Base: ⊆, show, big, \

export derivative, jacobian

include("region.jl")
export isempty_region, intersect_region, in_region, isequal_region,
    isbounded_region, isnai_region, bisect_region

include("root_object.jl")
export Root, isunique, root_status, root_region

include("roots.jl")
export roots, converged_roots, unconverged_roots
export RootProblem

include("contractors.jl")
export Bisection, Newton, Krawczyk, contract

include("linear_eq.jl")
export gauss_seidel_interval, gauss_elimination_interval, gauss_seidel_contractor

include("complex.jl")

include("newton1d.jl")
include("quadratic.jl")
include("slopes.jl")

end

# Example functions from Dietmar Ratz - An Optimized Interval Slope Arithmetic and its Application

dr1(x) = (x + sin(x)) * exp(-x^2)
dr2(x) = x^4 - 10x^3 + 35x^2 - 50x + 24
dr3(x) = (log(x + 1.25) - 0.84x) ^ 2
dr4(x) = 0.02x^2 - 0.03exp(-(20(x - 0.875))^2)
dr5(x) = exp(x^2)
dr6(x) = x^4 - 12x^3 + 47x^2 - 60x - 20exp(-x)
dr7(x) = x^6 - 15x^4 + 27x^2 + 250
dr8(x) = atan(cos(tan(x)))
dr9(x) = asin(cos(acos(sin(x))))

dr_functions = [dr1, dr2, dr3, dr4, dr5, dr6, dr7, dr8, dr9]

"""
    Root

Object representing a possible root inside a given region. The field `status`
is either `:unknown` or `:unique`. If `status` is `:unique` then we know that
there is a unique root of the function in question inside the given region.

Internally the status may also be `:empty` for region guaranteed to contain no
root, however such `Root`s are discarded by default and thus never returned by
the `roots` function.

# Fields
  - `region`: a region (either `Interval` or `SVector` of interval
        representing an interval box) searched for roots.
  - `status`: the status of the region, valid values are `:empty`, `unknown`
        and `:unique`.
  - `convergence`: the convergence status of the region. It is always `:converged`
        for roots with status `:unique`,
        and can be either `:max_iterartion` or `:tolerance` for roots with status `:unknown`,
        depending on whether they stopped being processing due to reaching
        the maximum number of iteration or the tolerance, respectively.
  - `error`: an error that was encounter but ignored during the processing of this region.
        Set to `nothing` if no error was encountered.
        The ignored errors are controlled by the `ignored_errors` field of the `RootProblem`.
"""
struct Root{T}
    region::T
    status::Symbol
    convergence::Symbol
    error
end

function Root(region, status::Symbol, convergence = :none, error = nothing)
    return Root(region, status, convergence, error)
end

"""
    root_status(rt)

Return the status of a `Root`.
"""
root_status(rt::Root) = rt.status  # Use root_status since just `status` is too generic

"""
    root_region(rt)

Return the region associated to a `Root`.
"""
root_region(rt::Root) = rt.region

"""
    isunique(rt)

Return whether a `Root` is unique.
"""
isunique(rt::Root{T}) where {T} = (rt.status == :unique)

function show(io::IO, rt::Root)
    print(io, "Root($(rt.region), :$(rt.status))")

    if !get(io, :compact, false) && rt.status == :unknown
        connector = isnothing(rt.error) ? "└" : "├"
        
        if rt.convergence == :tolerance
            print(io, "\n $connector Not converged: region size smaller than the tolerance")
        elseif rt.convergence == :max_iterartion 
            print(io, "\n $connector Not converged: reached maximal number of iterations")
        elseif rt.convergence == :none
            print(io, "\n $connector Not converged: the root is still being processed")
        else
            print(io, "\n $connector Not converged: unknown reason $(rt.convergence)")
        end

        if !isnothing(rt.error)
            print(io, "\n ├ Warning: error encountered during computation (use showerror(root.error) to see the whole stacktrace)\n └ ")
            showerror(io, rt.error[1])
        end
    end
end

Base.showerror(io::IO, rt::Root) = showerror(io, rt.error...)
Base.showerror(rt::Root) = showerror(stdout, rt.error...)

⊆(a::Interval, b::Root) = a ⊆ b.region
⊆(a::Root, b::Root) = a.region ⊆ b.region

IntervalArithmetic.diam(r::Root) = diam_region(root_region(r))
IntervalArithmetic.mag(r::Root) = mag_region(root_region(r))
IntervalArithmetic.mig(r::Root) = mig_region(root_region(r))
IntervalArithmetic.isnai(r::Root) = isnai_region(root_region(r))

function Base.:(==)(r1::Root, r2::Root)
    root_status(r1) != root_status(r2) && return false
    return isequal_region(root_region(r1), root_region(r2))
end

big(a::Root) = Root(big(a.interval), a.status)

"""
    Base.iterate(r::Root [, state])

Return successively the root region and status,
allowing to unpack the root object as `region, status = root`.
"""
function Base.iterate(r::Root{T}, state::Integer=1) where {T}
    state == 1 && return (r.region, 2)
    state == 2 && return (r.status, 3)
    return nothing
end

using IntervalArithmetic
using IntervalArithmetic.Symbols
using IntervalRootFinding

# Find roots of a function in a search region with defaul parameters
rts = roots(sin, -5 .. 5)
rts = roots(sin, -5 .. 6 ; contractor = Bisection, abstol = 1e-1)

# Refine roots with different options
rts = vcat(roots.(sin, rts ; contractor = Krawczyk)...)

# 2D:
f(x, y) = [x^2 + y^2 - 1, y - x]
f(X) = f(X...)  # Function must take a single vector as input

rts = roots(f, [-5 .. 5, -5 .. 5])

# When defining function mixing numbers and intervals use @exact to avoid the NG interval flag
@exact fe(x, y) = [x^2 + y^2 - 1, y - x]
fe(X) = fe(X...)  # Function must take a single vector as input
rts = roots(fe, [-5 .. 5, -5 .. 5])


# From R docs:
# https://www.rdocumentation.org/packages/pracma/versions/1.9.9/topics/broyden
# For performance use SVector
using StaticArrays

function g(x)
    (x1, x2, x3) = x
    SVector(    x1^2 + x2^2 + x3^2 - 1,
                x1^2 + x3^2 - 0.25,
                x1^2 + x2^2 - 4x3
            )
end

X = (-5 .. 5)
rts = roots(g, SVector(X, X, X))

h(xv) = ((x,y) = xv; SVector(2*x - y - exp(-x), -x + 2*y - exp(-y)))
rts = roots(h, SVector(X, X))

# Dennis-Schnabel:
h(xv) = ((x, y) = xv; SVector(x^2 + y^2 - 2, exp(x - 1) + y^3 - 2))
rts = roots(h, SVector(X, X))

# Test suites:
# http://folk.uib.no/ssu029/Pdf_file/Testproblems/testprobRheinboldt03.pdf
# http://www.mat.univie.ac.at/~neum/glopt/test.html
# http://titan.princeton.edu/TestProblems/
# http://www-sop.inria.fr/saga/POL/

##  MINPACK benchmarks: https://github.com/JuliaNLSolvers/NLsolve.jl/blob/master/test/minpack.jl

rosenbrock(xx) = ( (x, y) = xx; SVector( 1 - x, 1000 * (y - x^2) ) )
X = SVector(-1e5 .. 1e5, -1e5 .. 1e5)

rts = roots(rosenbrock, X)

# and other files in NLsolve test suite
# Testing unconstrained optimization software, Moré, Garbow, Hillstrom ACM Trans. Math. Soft. 7 (1), 17-41 (1981)

"""
    preconditioner(A, b)

Preconditions the matrix `A` and `b` with the inverse of `mid(A)`
"""
function preconditioner(A::AbstractMatrix, b::AbstractArray)
    Aᶜ = mid.(A)
    det(Aᶜ) == 0 && return A, b
    B = interval.(inv(Aᶜ))
    return B*A, B*b
end

function gauss_seidel_interval(A::AbstractMatrix, b::AbstractArray; precondition=true, maxiter=100)
    x = similar(b)
    x .= -1e16 .. 1e16
    gauss_seidel_interval!(x, A, b, precondition=precondition, maxiter=maxiter)
    return x
end
"""
    gauss_seidel_interval!(x, A, b; precondition=true, maxiter=100)

Iteratively solves the system of interval linear
equations and returns the solution set. Uses the
Gauss-Seidel method (Hansen-Sengupta version) to solve the system.
Keyword `precondition` to turn preconditioning off.

Reference: [Hansen and Walster (2003), Chapter 5, Page 115](@cite hansen2003)
"""
function gauss_seidel_interval!(x::AbstractArray, A::AbstractMatrix, b::AbstractArray; precondition=true, maxiter=100)
    precondition && ((A, b) = preconditioner(A, b))
    n = size(A, 1)

    @inbounds for iter in 1:maxiter
        x¹ = copy(x)
        for i in 1:n
            Y = b[i]
            for j in 1:n
                (i == j) || (Y -= A[i, j] * x[j])
            end
            Z = extended_div(Y, A[i, i])
            x[i] = hull((x[i] ∩ Z[1]), x[i] ∩ Z[2])
        end
        if all(x .== x¹)
            break
        end
    end
    x
end

function gauss_seidel_contractor(A::AbstractMatrix, b::AbstractArray; precondition=true, maxiter=100)
    x = similar(b)
    x .= -1e16 .. 1e16
    x = gauss_seidel_contractor!(x, A, b, precondition=precondition, maxiter=maxiter)
    return x
end

function gauss_seidel_contractor!(x::AbstractArray, A::AbstractMatrix, b::AbstractArray; precondition=true, maxiter=100)
    precondition && ((A, b) = preconditioner(A, b))

    n = size(A, 1)

    diagA = Diagonal(A)
    extdiagA = copy(A)
    for i in 1:n
        if (typeof(b) <: SArray)
            extdiagA = setindex(extdiagA, Interval(0), i, i)
        else
            extdiagA[i, i] = Interval(0)
        end
    end
    inv_diagA = inv(diagA)

    for iter in 1:maxiter
        x¹ = copy(x)
        x = x .∩ (inv_diagA * (b - extdiagA * x))
        if all(x .== x¹)
            break
        end
    end
    x
end

function gauss_elimination_interval(A0::AbstractMatrix, b0::AbstractArray ; precondition=true)
    if precondition
        A0, b0 = preconditioner(A0, b0)
    end

    A = similar(A0)
    A .= A0
    b = similar(b0)
    b .= b0
    n = size(A, 1)

    p = similar(b)
    p .= interval(0)

    if any(a -> in_interval(0, a), diag(A))
        p .= interval(-Inf, Inf)
        return p
    end

    for i in 1:(n-1)
        for j in (i+1):n
            α = A[j, i] / A[i, i]
            b[j] -= α * b[i]

            for k in (i+1):n
                A[j, k] -= α * A[i, k]
            end
        end
    end

    for i in n:-1:1
        temp = zero(b[1])

        for j in (i+1):n
            temp += A[i, j] * p[j]
        end

        p[i] = (b[i] - temp) / A[i, i]
    end

    return p
end

function gauss_elimination_interval(A::AbstractMatrix, B::AbstractMatrix ; kwargs...)
    return mapreduce(hcat, eachcol(B)) do b
        return gauss_elimination_interval(A, b ; kwargs...)
    end
end

"""
    gauss_elimination_interval!(x, A, b; precondition=true)

Solves the system of linear equations using Gaussian Elimination.
Preconditioning is used when the `precondition` keyword argument is `true`.

Reference: [Jaulin et al. (2001), p.72](@cite jaulin2001)
"""
function gauss_elimination_interval!(x::AbstractArray, A::AbstractMatrix, b::AbstractArray; precondition=true)
    if precondition
        A, b = preconditioner(A, b)
    end
    A = copy(A)
    b = copy(b)

    n = size(A, 1)

    p = similar(b)
    p .= 0

    any(a -> in_interval(0, a), diag(A)) && return x

    for i in 1:(n-1)
        for j in (i+1):n
            α = A[j, i] / A[i, i]
            b[j] -= α * b[i]

            for k in (i+1):n
                A[j, k] -= α * A[i, k]
            end
        end
    end

    for i in n:-1:1
        temp = zero(b[1])

        for j in (i+1):n
            temp += A[i, j] * p[j]
        end

        p[i] = (b[i] - temp) / A[i, i]
    end

    return intersect_region(p, x)
end

function gauss_elimination_interval1(A::AbstractMatrix, b::AbstractArray; precondition=true)

    n = size(A, 1)
    x = fill(-1e16 .. 1e16, n)

    x = gauss_elimination_interval1!(x, A, b, precondition=precondition)

    return x
end
"""
    gauss_elimination_interval1!(x, a, b; precondition=true)

Using `Base.\\`
"""
function gauss_elimination_interval1!(x::AbstractArray, a::AbstractMatrix, b::AbstractArray; precondition=true)

    precondition && ((a, b) = preconditioner(a, b))

    a \ b
end

\(A::SMatrix{S, S, Interval{T}}, b::SVector{S, Interval{T}}; kwargs...) where {S, T} = gauss_elimination_interval(A, b, kwargs...)
\(A::Matrix{Interval{T}}, b::Vector{Interval{T}}; kwargs...) where T = gauss_elimination_interval(A, b, kwargs...)

export branch_and_prune, Bisection, Newton

struct RootProblem{C, F, G, R, S, T}
    contractor::Type{C}
    f::F
    derivative::G
    region::R
    search_order::Type{S}
    abstol::T
    reltol::T
    max_iteration::Int
    where_bisect::T
    ignored_errors::Vector{DataType}
end

"""
    RootProblem(f::Function, search_region ; kwargs...)

Setup a `RootProblem` for searching the roots (also known as zeros)
of the function `f` in the given search region.

`search_region` must be either an `Interval` if `f` is scalar
or a vector of `Interval`s if `f` is vector-valued.

The returned `RootProblem` is an iterator that give access to the internal
state of the search during the iteration,
allowing to add callbacks and logging to the search.

Keyword parameters
==========
- `contractor`: Contractor used to determine the status of a region.
    Must be either `Newton`, `Krawczyk`, or `Bisection`. `Bisection` do not require
    to compute the derivative of the function, but can also never guarantee the
    existence of a root. Default: `Newton`.
- `derivative`: Explicit derivative of the function (or its jacobian for
    vector-valued functions) used by the `Newton` and `Krawczyk` contractors.
    Default: `nothing` (the derivative is computed automatically using ForwardDiff.jl).
- `search_order`: Order in which the sub-regions are searched.
    `BreadthFirst` (visit the largest regions first) and `DepthFirst`
    (visit the smallest regions first) are supported. Default: `BreadthFirst`.
- `abstol`: Absolute tolerance. The search is stopped when all dimensions
    of the remaining regions are smaller than `abstol`. Default: `1e-7`.
- `reltol`: Relative tolerance. The search is stopped when all dimensions
    of the remaining regions are smaller than `reltol * mag(interval)`.
    Default: `0.0`.
- `max_iteration`: The maximum number of iteration, which also corresponds to
    the maximum number of bisections allowed. Default: `100_000`.
- `infer_root_type`: When true, use the return type of the function as
    type for the region in the returned roots, avoiding extra conversions
    during the computation.
    Otherwise, use the type of the provided region.
    Default: `true`. Always `false` if the initial region is given as a `Root`.
- `where_bisect`: Value used to bisect the region. It is used to avoid
    bisecting exactly on zero when starting with symmetrical regions,
    often leading to having a solution directly on the boundary of a region,
    which prevent the contractor to prove it's unicity. Default: `127/256`.
-`ignored_errors`: List of exceptions that are ignored during the processing
    of a region. If the error is encoutered, it is discarded and the region is bisected
    further.
    Default: `[IntervalArithmetic.InconclusiveBooleanOperation]`.
"""
function RootProblem(f, region ; infer_root_type = true, kwargs...)
    if infer_root_type
        T = last(InteractiveUtils.@code_typed(f(region)))
        if isconcretetype(T)
            region = convert(T, region)
        else
            @warn "Could not infer the return type of the function (it may be type instable). Got $T"
        end
    end
    RootProblem(f, Root(region, :unkown) ; kwargs...)
end

function RootProblem(
        f, root::Root ;
        contractor = Krawczyk,
        derivative = nothing,
        search_order = BreadthFirst,
        abstol = 1e-7,
        reltol = 0.0,
        max_iteration = 100_000,
        where_bisect = 0.49609375,  # 127//256
        ignored_errors = [IntervalArithmetic.InconclusiveBooleanOperation])
    
    N = length(root_region(root))
    if isnothing(derivative)
        if N == 1
            derivative = x -> ForwardDiff.derivative(f, x)
        else
            derivative = x -> ForwardDiff.jacobian(f, x)
        end
    end

    RootProblem(
        contractor,
        f,
        derivative,
        root,
        search_order,
        abstol,
        reltol,
        max_iteration,
        where_bisect,
        convert(Vector{DataType}, ignored_errors)
    )
end

Base.show(io::IO, pb::RootProblem) = print(io, """
    RootProblem
      Contractor: $(pb.contractor)
      Function: $(pb.f)
      Search region: $(root_region(pb.region))
      Search order: $(pb.search_order)
      Absolute tolerance: $(pb.abstol)
      Relative tolerance: $(pb.reltol)
      Maximum iterations: $(pb.max_iteration)
      Ignored errors: $(pb.ignored_errors)"""
)

roots(state::SearchState) = regions(state)
converged_roots(state::SearchState) = finished_regions(state)
unconverged_roots(state::SearchState) = unfinished_regions(state)

function Base.iterate(root_problem::RootProblem, state = nothing)
    if isnothing(state)
        search = root_search(root_problem)
        bp_iteration = iterate(search)
    else
        search, search_state = state
        bp_iteration = iterate(search, search_state)
    end
    isnothing(bp_iteration) && return nothing
    bp_search_state = bp_iteration[2]
    bp_search_state.iteration > root_problem.max_iteration && return nothing
    return bp_search_state, (search, bp_search_state)
end
   
function bisect_region(r::Root, α)
    Y1, Y2 = bisect_region(root_region(r), α)
    return Root(Y1, :unknown), Root(Y2, :unknown)
end

function under_tolerance(root_problem, root::Root)
    d = diam(root)
    d < root_problem.abstol && return true
    d / mag(root) < root_problem.reltol && return true
    return false
end

function process(root_problem, root::Root)
    contracted = nothing
    try
        contracted = contract(root_problem, root)
    catch err
        !any(isa(err, Err) for Err in root_problem.ignored_errors) && rethrow()
        contracted = Root(root.region, :unknown, :none, (err, backtrace()))
    end

    status = root_status(contracted)

    if status == :unique
        refined_root = refine(root_problem, contracted)
        return :store, refined_root
    end

    status == :empty && return :prune, root

    if status == :unknown
        # Avoid infinite division of intervals with singularity
        if istrivial(contracted.region) && under_tolerance(root_problem, root)
            return :store, Root(root.region, :unknown, :tolerance)
        end

        if under_tolerance(root_problem, contracted)
            return :store, Root(contracted.region, :unknown, :tolerance, contracted.error)
        end
        
        return :branch, root
    else
        throw(ArgumentError("unrecognized root status: $status"))
    end
end

root_search(root_problem::RootProblem) = BranchAndPruneSearch(
    root_problem.search_order,
    X -> process(root_problem, X),
    X -> bisect_region(X, root_problem.where_bisect),
    root_problem.region
)

"""
    roots(f::Function, search_region ; kwargs...)

Return the roots (also known as zeros) of the function `f`
contained in the given search region
(either an `Interval` for a scalar function or vector of `Interval`s for a
vector valued function),
together with a status.

The status of the returned regions can be either of
- `:unique`: the region provably contains exactly one root of `f`
- `:unknown`: the region may contain any number of roots (potentially none)

The parts of the search region that are not covered by any of the returned
roots are guaranteed to contain no root of the function.

For information about the optional search parameters,
see [`RootProblem`](@ref).
"""
function roots(f, region ; kwargs...)
    problem = RootProblem(f, region ; kwargs...)
    state = nothing

    for outer state in problem end

    result = BranchAndPrune.BranchAndPruneResult(
        state.search_order,
        problem.region,
        state.tree
    )

    rts = vcat(result.final_regions, result.unfinished_regions)
    return map(rts) do rt
        if rt.status == :unknown && rt.convergence == :none
            return Root(rt.region, rt.status, :max_iterartion, rt.error)
        end
        return rt
    end
end

# Acting on complex `Interval`
function roots(f, region::Complex{<:Interval} ; derivative = nothing, contractor = Krawczyk, kwargs...)
    g = realify(f)
    X = [real(region), imag(region)]

    contractor != Bisection && isnothing(derivative) && throw(
        ArgumentError("when using complex numbers, the derivative must be " *
        "given explicitly as ForwardDiff does not support complex numbers.")
    )

    dg = realify_derivative(derivative)

    rts = roots(g, X ; derivative = dg, contractor, kwargs...)
    return [Root(Complex(root_region(rt)...), root_status(rt)) for rt in rts]
end

using BranchAndPrune
using IntervalRootFinding
using IntervalArithmetic.Symbols
using ForwardDiff
using StaticArrays
using Suppressor
using Test

newtonlike_methods = [Newton, Krawczyk]

# Compute the distance between set of roots
function roots_dist(rt1::Root{<:Interval}, rt2::Root{<:Interval})
    d = dist(root_region(rt1), root_region(rt2))
    return sum(d)
end

function roots_dist(rt1::Root{<:AbstractVector}, rt2::Root{<:AbstractVector})
    return sum(dist.(root_region(rt1), root_region(rt2)))
end

function roots_dist(rt1::Root{Complex{<:Interval}}, rt2::Root{Complex{<:Interval}})
    dreal = dist(real(root_region(rt1)), real(root_region(rt2)))
    dimag = dist(imag(root_region(rt1)), imag(root_region(rt2)))

    return sum(dreal) + sum(dimag)
end

# Test that a contractor that use derivatives
# Check that all return roots are unique, and that giving the derivative explictly
# makes no difference
function test_newtonlike(f, derivative, X, contractor, nsol, tol=1e-10)
    rts = roots(f, X ; contractor)
    @test length(rts) == nsol
    @test all(isunique, rts)
    @test sum(roots_dist.(rts, roots(f, X ; contractor, derivative))) < tol
end

# Check that a given point is in one of the given intervals
function in_solution_set(point, solution_intervals)
    return any(map(Y -> in_region(point, Y), solution_intervals))
end

include("roots.jl")
include("stationary_points.jl")

include("multidimensional.jl")
include("svectors.jl")

include("test_smiley.jl")
include("linear_eq.jl")

@testset "Example files" begin
    for file in readdir("../examples/", join = true)
        include(file)
        @test true
    end
end

@testset "Static vectors" begin
    f(xx) = [xx[1]^2 - 1, xx[2]^2 - 2]
    g(xx) = SVector(xx[1]^2 - 1, xx[2]^2 - 2)

    X = [interval(-5, 5), interval(-5, 5)]
    S = SVector(interval(-5, 5), interval(-5, 5))

    @testset for contractor in newtonlike_methods
        rts = roots(f, X ; contractor)
        rts2 = roots(g, S ; contractor)

        for (rt, rt2) in zip(rts, rts2)
            @test isequal_interval(
                root_region(rt),
                root_region(rt2)
            )
        end
    end
end

@testset "Stationary points" begin
    f(xx) = ( (x, y) = xx; sin(x) * sin(y) )
    gradf = xx -> ForwardDiff.gradient(f, xx)

    XX = [interval(-5, 6), interval(-5, 6)]
    tol = 1e-5

    for method in newtonlike_methods
        deriv = xx -> ForwardDiff.jacobian(gradf, xx)
        test_newtonlike(gradf, deriv, XX, method, 25, tol)
    end

    # Rastrigin function
    function rastrigin(x, y, A)
        return 2A + x^2 - A*cos(2π*x) + y^2 - A*cos(2π*y)
    end

    f(xy) = rastrigin(xy..., 10)

    ∇f = X -> ForwardDiff.gradient(f, X)

    L = 5.0
    X = interval(-L, (L+1))
    XX = [X, X]

    rts = IntervalRootFinding.roots(∇f, XX ; contractor = Newton, abstol = 1e-5)
    rts2 = IntervalRootFinding.roots(∇f, XX ; contractor = Krawczyk, abstol = 1e-5)

    @test length(rts) == length(rts2) == 529
    @test all(isunique, rts)
    @test all(isunique, rts2)
end

using IntervalArithmetic, IntervalRootFinding
using Documenter
using DocumenterCitations

bib = CitationBibliography(joinpath(@__DIR__, "src", "refs.bib"); style = :numeric)

makedocs(
    modules = [IntervalRootFinding],
    doctest = true,
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true"),
    sitename = "IntervalRootFinding.jl",
    authors = "David P. Sanders and Luis Benet",
    pages = Any[
        "Home" => "index.md",
        "`roots` interface" => "roots.md",
        "Decorations and guarantees" => "decorations.md",
        "Internals" => "internals.md",
        "Bibliography" => "biblio.md",
        "API" => "api.md"
    ],
    plugins = [bib],
)

deploydocs(
    repo = "github.com/JuliaIntervals/IntervalRootFinding.jl.git",
    target = "build",
    deps = nothing,
    make = nothing
)

@testset "2D roots" begin
    f(x, y) = [x^2 + y^2 - 1, y - 2x]
    f(X) = f(X...)
    X = [interval(-6, 6), interval(-6, 6)]

    # Bisection
    rts = roots(f, X ; contractor = Bisection, abstol = 1e-3)
    exact_sol = [sqrt(1/5), 2sqrt(1/5)]
    @test in_solution_set(exact_sol, root_region.(rts))
    @test in_solution_set(-exact_sol, root_region.(rts))

    for contractor in newtonlike_methods
        deriv = xx -> ForwardDiff.jacobian(f, xx)
        test_newtonlike(f, deriv, X, contractor, 2)
        rts = roots(f, X ; contractor)
        @test in_solution_set(exact_sol, root_region.(rts))
        @test in_solution_set(-exact_sol, root_region.(rts))
    end

    # Infinite interval
    X = [interval(-Inf, Inf), interval(-Inf, Inf)]
    @suppress rts = roots(f, X ; contractor = Newton)
    @test length(rts) == 2
end


# From R docs:
# https://www.rdocumentation.org/packages/pracma/versions/1.9.9/topics/broyden

@testset "3D roots" begin
    function g(x)
        (x1, x2, x3) = x
        SVector(    x1^2 + x2^2 + x3^2 - 1,
                    x1^2 + x3^2 - 0.25,
                    x1^2 + x2^2 - 4x3
                )
    end
    dg = xx -> ForwardDiff.jacobian(g, xx)

    X = interval(-5, 5)
    XX = [X, X, X]

    for contractor in newtonlike_methods
        rts = roots(g, XX ; contractor)
        @test length(rts) == 4
        @test all(isunique, rts)
        @test all(rts .== roots(g, XX ; contractor, derivative = dg))
    end
end

@testset "10D roots" begin
    include("../examples/10_dimensional.jl")

    for contractor in newtonlike_methods
        rts = roots(f10d, X10d_large ; contractor, max_iteration = 50_000)
        @test any(X -> all(in_interval.(sol10d, X.region)), rts)

        rts = roots(f10d, X10d_close ; contractor, max_iteration = 1_000_000)
        @test length(rts) == 1
        @test isunique(rts[1])
    end
end

@testset "Dimension mismatch" begin
    f21(xy) = [xy[1]^2 - 2]
    f23(xy) = [xy[1]^2 - 2, xy[2]^2 - 3, xy[1] + xy[2]]

    X = [interval(0, 5), interval(0, 5)]

    for contractor in newtonlike_methods
        @test_throws DimensionMismatch roots(f21, X ; contractor)
        @test_throws DimensionMismatch roots(f23, X ; contractor)
    end
end

using BenchmarkTools
using ForwardDiff
using IntervalArithmetic
using IntervalRootFinding
import Random
using StaticArrays

const SUITE = BenchmarkGroup()

Random.seed!(0)  # Seed the RNG to get consistent results
tol = 1e-10

## Smiley and Chun examples
include("../examples/smiley_examples.jl")
using .SmileyExample22, .SmileyExample52, .SmileyExample54, .SmileyExample55

S = SUITE["Smiley"] = BenchmarkGroup()

for example in (SmileyExample22, SmileyExample52, SmileyExample54, SmileyExample55)
    s = S[example.title] = BenchmarkGroup()
    for contractor in (Newton, Krawczyk)
        s[string(contractor)] = @benchmarkable roots($(example.f), $(example.region) ; contractor = $contractor, abstol = $tol, infer_root_type = false)
    end
end


## Rastrigin function
S = SUITE["Rastigrin stationary points"] = BenchmarkGroup()

const A = 10

f(x, y) = 2A + x^2 - A*cos(2π*x) + y^2 - A*cos(2π*y)
f(X) = f(X...)

∇f = X -> ForwardDiff.gradient(f, X)

L = 5.0
X = SVector(interval(-L, (L+1)), interval(-L, (L+1)))

for contractor in (Newton, Krawczyk)
    S[string(contractor)] = @benchmarkable roots($(∇f), $X ; contractor = $contractor, abstol = 1e-5, infer_root_type = false)
end


## Dietmar-Ratz functions
include("dietmar_ratz_functions.jl")

S = SUITE["Dietmar-Ratz"] = BenchmarkGroup()

X = interval(0.75, 1.75)

for (k, dr) in enumerate(dr_functions)
    s = S["Dietmar-Ratz $k"] = BenchmarkGroup()

    if k != 8  # dr8 is excluded as it has too many roots
        for contractor in (Newton, Krawczyk)
            s[string(contractor)] = @benchmarkable roots($dr, $X ; contractor = $contractor, abstol = $tol, infer_root_type = false)
        end
    end
end

# 10 dimensional problem
include("../examples/10_dimensional.jl")

S = SUITE["10 dimensional"] = BenchmarkGroup()

for contractor in (Newton, Krawczyk)
    S[string(contractor)] = @benchmarkable roots($f10d, $X10d_close ; contractor = $contractor, abstol = $tol, max_iteration = 1_000_000)
end

# Reference : Dietmar Ratz - An Optimized Interval Slope Arithmetic and its Application
using IntervalArithmetic, ForwardDiff
import Base: +, -, *, /, ^, sqrt, exp, log, sin, cos, tan, asin, acos, atan
import IntervalArithmetic: mid, interval

function slope(f::Function, x::Interval, c::Number)
    f(slope_var(x, c)).s
end

struct Slope{T}
    x::Interval{T}  # Interval on which slope is evaluated
    c::Interval{T}  # Point about which slope is evaluated (Interval to get bounded rounding errors)
    s::Interval{T}  # Variable which propogates the slope information
end

Slope(c) = Slope(c, c, 0)
Slope(a, b, c) = Slope(promote(convert(Interval, a), b, c)...)

function slope_var(v::Number)
    Slope(v, v, 1)
end

function slope_var(v::Interval, c::Number)
    Slope(v, c, 1)
end

function interval(u::Slope)
    u.x
end

function mid(u::Slope)
    u.c
end

function slope(u::Slope)
    u.s
end

function +(u::Slope, v::Slope)
    Slope(u.x + v.x, u.c + v.c, u.s + v.s)
end

function -(u::Slope, v::Slope)
    Slope(u.x - v.x, u.c - v.c, u.s - v.s)
end

function *(u::Slope, v::Slope)
    Slope(u.x * v.x, u.c * v.c, u.s * v.c + u.x * v.s)
end

function /(u::Slope, v::Slope)
    Slope(u.x / v.x, u.c / v.c, (u.s - (u.c / v.c) * v.s) / v.x)
end

function +(u, v::Slope)
    Slope(u + v.x, u + v.c, v.s)
end

function -(u, v::Slope)
    Slope(u - v.x, u - v.c, -v.s)
end

function *(u, v::Slope)
    Slope(u * v.x, u * v.c, u * v.s)
end

function /(u, v::Slope)
    Slope(u / v.x, u / v.c, -(u / v.c) * (v.s / v.x))
end

+(v::Slope, u) = u + v

*(v::Slope, u) = u * v

function -(u::Slope, v)
    Slope(u.x - v, u.c - v, u.s)
end

function -(u::Slope)
    Slope(-u.x, -u.c, -u.s)
end

function /(u::Slope, v)
    Slope(u.x / v, u.c / v, u.s / v)
end

function sqr(u::Slope)
    Slope(u.x ^ 2, u.c ^ 2, (u.x + u.c) * u.s)
end

function ^(u::Slope, k::Integer)
    if k == 0
        return Slope(1)
    elseif k == 1
        return u
    elseif k == 2
        return sqr(u)
    else
        hxi = interval(u.x.lo) ^ k
        hxs = interval(u.x.hi) ^ k
        hx = hull(hxi, hxs)

        if (k % 2 == 0) && (0 ∈ u.x)
            hx = interval(0, hx.hi)
        end

        hc = u.c ^ k

        i = u.x.lo - u.c.lo
        s = u.x.hi - u.c.hi

        if ((i == 0) || (s == 0) || (k % 2 == 1 && zero(u.x) ⪽ u.x))
            h1 = k * (u.x ^ (k - 1))
        else
            if k % 2 == 0 || u.x.lo >= 0
                h1 = interval((hxi.hi - hc.lo) / i, (hxs.hi - hc.lo) / s)
            else
                h1 = interval((hxs.lo - hc.hi) / s, (hxi.lo - hc.hi) / i)
            end
        end
        return Slope(hx, hc, h1 * u.s)
    end
end

function sqrt(u::Slope)
    Slope(sqrt(u.x), sqrt(u.c), u.s / (sqrt(u.x) + sqrt(u.c)))
end

function exp(u::Slope)
    hx = exp(u.x)
    hc = exp(u.c)

    i = u.x.lo - u.c.lo
    s = u.x.hi - u.c.hi

    if (i == 0 || s == 0)
        h1 = hx
    else
        h1 = interval((hx.lo - hc.lo) / i, (hx.hi - hc.hi) / s)
    end

    Slope(hx, hc, h1 * u.s)
end

function log(u::Slope)
    hx = log(u.x)
    hc = log(u.c)

    i = u.x.lo - u.c.lo
    s = u.x.hi - u.c.hi

    if (i == 0 || s == 0)
        h1 = 1 / u.x
    else
        h1 = interval((hx.hi - hc.hi) / s, (hx.lo - hc.lo) / i)
    end
    Slope(hx, hc, h1 * u.s)
end

function sin(u::Slope) # Using derivative to upper bound the slope expansion for now
    hx = sin(u.x)
    hc = sin(u.c)
    hs = cos(u.x)
    Slope(hx, hc, hs)
end

function cos(u::Slope) # Using derivative to upper bound the slope expansion for now
    hx = cos(u.x)
    hc = cos(u.c)
    hs = -sin(u.x)
    Slope(hx, hc, hs)
end

function tan(u::Slope) # Using derivative to upper bound the slope expansion for now
    hx = tan(u.x)
    hc = tan(u.c)
    hs = (sec(u.x)) ^ 2
    Slope(hx, hc, hs)
end

function asin(u::Slope)
    hx = asin(u.x)
    hc = asin(u.c)
    hs = 1 / sqrt(1 - (u.x ^ 2))
    Slope(hx, hc, hs)
end

function acos(u::Slope)
    hx = acos(u.x)
    hc = acos(u.c)
    hs = -1 / sqrt(1 - (u.x ^ 2))
    Slope(hx, hc, hs)
end

function atan(u::Slope)
    hx = atan(u.x)
    hc = atan(u.c)
    hs = 1 / 1 + (u.x ^ 2)
    Slope(hx, hc, hs)
end

using IntervalArithmetic, IntervalRootFinding
using ForwardDiff
using Test

struct Slopes{T}
    f::Function
    x::Interval{T}
    c::T
    sol::Interval{T}
end

@testset "Automatic slope expansion" begin
    for T in [Float64, BigFloat]
        s = interval(T(0.75), T(1.75))
        example = Slopes{T}[]
        push!(example, Slopes(x->((x + sin(x)) * exp(-x^2)), s, mid(s), interval(T(-2.8), T(0.1))))
        push!(example, Slopes(x->(x^4 - 10x^3 + 35x^2 - 50x + 24), s, mid(s), interval(T(-44), T(38.5))))
        push!(example, Slopes(x->((log(x + 1.25) - 0.84x) ^ 2), s, mid(s), interval(T(-0.16), T(0.44))))
        push!(example, Slopes(x->(0.02x^2 - 0.03exp(-(20(x - 0.875))^2)), s, mid(s), interval(T(0.03), T(0.33))))
        push!(example, Slopes(x->(exp(x^2)), s, mid(s), interval(T(6.03), T(33.23))))
        push!(example, Slopes(x->(x^4 - 12x^3 + 47x^2 - 60x - 20exp(-x)), s, mid(s), interval(T(-39), T(65.56))))
        push!(example, Slopes(x->(x^6 - 15x^4 + 27x^2 + 250), s, mid(s), interval(T(-146.9), T(67.1))))
        push!(example, Slopes(x->(atan(cos(tan(x)))), s, mid(s), interval(T(1), T(2))))
        push!(example, Slopes(x->(asin(cos(acos(sin(x))))), s, mid(s), interval(T(1.36), T(Inf))))

        for i in eachindex(example)
            s = slope(example[i].f, example[i].x, example[i].c)
            @test issubset_interval(s, example[i].sol)
        end
    end
end

"""
    newton1d(f, f′, x::Interval; [reltol,] [abstol,] [debug,] [debugroot])

`newton1d` performs the interval Newton method on the given function `f`
with its derivative `f′` and initial interval `x`.
Optional keyword arguments give the tolerances `reltol` and `abstol`.
`reltol` is the tolerance on the relative error whereas `abstol` is the tolerance on `|f(X)|`,
and a `debug` boolean argument that prints out diagnostic information.
"""
function newton1d(f::Function, f′::Function, x::Interval{T};
                    reltol=eps(T), abstol=eps(T), debug=false, debugroot=false) where {T}

    L = Interval{T}[] # Array to hold the intervals still to be processed

    R = Root{Interval{T}}[] # Array to hold the `root` objects obtained
    reps = reps1 = 0

    push!(L, x) # Initialize
    initial_width = ∞
    X = emptyinterval(T) # Initialize
    while !isempty(L)   # Until all intervals have been processed
        X = pop!(L)     # Process next interval

        debug && (print("Current interval popped: "); @show X)

        m = mid(X)
        if (isempty(X))
            continue
        end

        if 0 ∉ f′(X)    # if 0 ∉ f′(X), Newton steps can be made normally until either X becomes empty, or is known to contain a unique root

            debug && println("0 ∉ f′(X)")

            while true

                m = mid(X)
                N = m - (f(interval(m)) / f′(X))    # Newton step

                debug && (print("Newton step1: "); @show (X, X ∩ N))
                if X == X ∩ N   # Checking if Newton step was redundant
                    reps1 += 1
                    if reps1 > 20
                        reps1 = 0
                        break
                    end
                end
                X = X ∩ N

                if (isempty(X))         # No root in X
                    break

                elseif 0 ∈ f(wideinterval(mid(X)))  # Root guaranteed to be in X
                    n = fa = fb = 0
                    root_exist = true
                    while (n < 4 && (fa == 0 || fb == 0))   # Narrowing the interval further
                        if fa == 0
                            if 0 ∈ f(wideinterval(X.lo))
                                fa = 1
                            else
                                N = X.lo - (f(interval(X.lo)) / f′(X))
                                X = X ∩ N
                                if (isempty(X))
                                    root_exist = false
                                    break
                                end
                            end
                        end
                        if fb == 0
                            if 0 ∈ f(wideinterval(X.hi))
                                fb = 1
                            else
                                if 0 ∈ f(wideinterval(mid(X)))
                                    N = X.hi - (f(interval(X.hi)) / f′(X))
                                else
                                    N = mid(X) - (f(interval(mid(X))) / f′(X))
                                end
                                X = X ∩ N
                                if (isempty(X))
                                    root_exist = false
                                    break
                                end
                            end
                        end
                        N = mid(X) - (f(interval(mid(X))) / f′(X))
                        X = X ∩ N
                        if (isempty(X))
                            root_exist = false
                            break
                        end
                        n += 1
                    end
                    if root_exist
                        push!(R, Root(X, :unique))
                        debugroot && @show "Root found", X  # Storing determined unique root
                    end

                    break
                end
            end

        else                                # 0 ∈ f′(X)
            if diam(X) == initial_width     # if no improvement occuring for a number of iterations
                reps += 1
                if reps > 10
                    push!(R, Root(X, :unknown))
                    debugroot && @show "Repeated root found", X
                    reps = 0
                    continue
                end
            end
            initial_width = diam(X)
            debug && println("0 ∈ f'(X)")

            expansion_pt = Inf
            # expansion point for the newton step might be m, X.lo or X.hi according to some conditions

            if 0 ∈ f(wideinterval(mid(X)))  # if root in X, narrow interval further
                # 0 ∈ fⁱ(x)

                debug && println("0 ∈ fⁱ(x)")

                if 0 ∉ f(wideinterval(X.lo))
                    expansion_pt = X.lo

                elseif 0 ∉ f(wideinterval(X.hi))
                    expansion_pt = X.hi

                else
                    x1 = mid(interval(X.lo, mid(X)))
                    x2 = mid(interval(mid(X), X.hi))
                    if 0 ∉ f(wideinterval(x1)) || 0 ∉ f(wideinterval(x2))
                        push!(L, interval(X.lo, m))
                        push!(L, interval(m, X.hi))
                        continue

                    else
                        push!(R, Root(X, :unknown))

                        debugroot && @show "Multiple root found", X

                        continue
                    end
                end

            else
                # 0 ∉ fⁱ(x)

                debug && println("0 ∉ fⁱ(x)")

                if (diam(X)/mag(X)) < reltol && diam(f(X)) < abstol     # checking if X is still within tolerances
                    push!(R, Root(X, :unknown))

                    debugroot && @show "Tolerance root found", X

                    continue
                end
            end
            # Step 8

            if isinf(expansion_pt)
                expansion_pt = mid(X)
            end


            a = f(interval(expansion_pt))
            b = f′(X)
            # Newton steps with extended division creating two intervals
            if 0 < b.hi && 0 > b.lo && 0 ∉ a
                if a.hi < 0
                    push!(L, X ∩ (expansion_pt - interval(-Inf, a.hi / b.hi)))
                    push!(L, X ∩ (expansion_pt - interval(a.hi / b.lo, Inf)))

                elseif a.lo > 0
                    push!(L, X ∩ (expansion_pt - interval(-Inf, a.lo / b.lo)))
                    push!(L, X ∩ (expansion_pt - interval(a.lo / b.hi, Inf)))

                end

                continue

            else
                N = expansion_pt - (f(interval(expansion_pt))/f′(X))

                debug && (print("Newton step2: "); @show (X, X ∩ N))

                X = X ∩ N
                m = mid(X)

                if isempty(X)
                    continue
                end
            end

            push!(L, X) # Pushing X into L to be processed again
        end
    end

    return R
end


"""
    newton1d(f, x::Interval; args...)

`newton1d` performs the interval Newton method on the given function `f` and initial interval `x`.
Optional keyword arguments give the tolerances `reltol` and `abstol`.
`reltol` is the tolerance on the relative error whereas `abstol` is the tolerance on `|f(X)|`,
and a `debug` boolean argument that prints out diagnostic information.
"""
newton1d(f::Function, x::Interval{T}; args...) where {T} =
    newton1d(f, x-> derivative(f,x), x; args...)

using IntervalArithmetic, StaticArrays, IntervalRootFinding
using Test

function rand_vec(n::Int)
    a = randn(n)
    A = interval.(a)
    mA = MVector{n}(A)
    sA = SVector{n}(A)
    return A, mA, sA
end

function rand_mat(n::Int)
    a = randn(n, n)
    A = interval.(a)
    mA = MMatrix{n, n}(A)
    sA = SMatrix{n, n}(A)
    return A, mA, sA
end

@testset "Linear Equations" begin

    As = [[2 .. 3 0 .. 1; 1 .. 2 2 .. 3], ]
    bs = [[0 .. 120, 60 .. 240], ]
    xs = [[-120 .. 90, -60 .. 240], ]

    for i in 1:10
        rand_A = rand_mat(i)[1]
        rand_x = rand_vec(i)[1]
        rand_b = rand_A * rand_x
        push!(As, rand_A)
        push!(bs, rand_b)
        push!(xs, rand_x)
    end

    n = length(As)

    @testset for solver in (gauss_seidel_interval, gauss_seidel_contractor, gauss_elimination_interval, \)
        if solver in (gauss_seidel_interval, gauss_seidel_contractor)
            @test_broken false
            continue
        end

        for i in 1:n
            soln = solver(As[i], bs[i])
            @test all(issubset_interval.(xs[i], soln))
        end
    end
end

@testset "Simple tests" begin
    # Default
    rts = roots(sin, interval(-5, 5))
    @test length(rts) == 3
    @test all(isunique, rts)

    # Bisection
    rts = roots(sin, interval(-5, 6) ; contractor = Bisection, abstol = 1e-3)
    @test length(rts) == 3

    @testset for contractor in newtonlike_methods
        # Refinement
        rts = roots(sin, interval(-5, 6) ; contractor = Bisection, abstol = 1e-3)
        for rt in rts
            refined = roots(sin, rt ; contractor)
            @test length(refined) == 1
            @test isunique(only(refined))
        end

        test_newtonlike(sin, cos, interval(-5, 5), contractor, 3)

        # abs
        g(p) = abs(1 / ( (1+p)^30 ) * 10_000 - 100)
        g2(p) = (1 / ( (1+p)^30 ) * 10_000 - 100)^2
        X = interval(-1000, 1000)
        rts = roots(g, X ; contractor)
        rts2 = roots(g2, X ; contractor)
        rr = intersect_interval.(root_region.(rts), root_region.(rts2))
        @test !any(isempty(rr))

        # Hard problem with a known zero at zero
        h(E) = tan(√(2E)) + √(E / (3π^2 - E))
        rts = roots(h, interval(-1e100, 1e100) ; contractor)
        @test any(rts) do rt
            in_interval(0, root_region(rt))
        end

        # Singularity
        s(x) = x + zero(x)/x
        rts = roots(s, interval(-1, 1) ; contractor)
        @test length(rts) == 1
        @test root_status(only(rts)) == :unknown
        @test in_interval(0, root_region(only(rts)))

        # Double reciprocal from #131
        rr(x) = 1/(1/(1 + x)*(1 - x))
        rts = roots(rr, interval(-10, 10) ; contractor)
        @test length(rts) == 2
        @test all(root_status(rt) == :unknown for rt in rts)
        @test in_interval(-1, root_region(rts[1]))
        @test in_interval(1, root_region(rts[2]))
    end
end

@testset "Multiple roots" begin
    f(x) = (x-1) * (x^2 - 2)^3 * (x^3 - 2)^4
    g(x) = exp(x) - x - 1  # Double root at 0 from Burden & Faires, 9th ed, p.84

    for contractor in newtonlike_methods
        rts = roots(f, interval(-5, 5) ; contractor)

        @test length(rts) == 4
        @test rts[1].status == :unknown
        @test in_interval(-sqrt(2), rts[1].region)

        @test rts[2].status == :unique
        @test in_interval(1, rts[2].region)

        @test rts[3].status == :unknown
        @test in_interval(cbrt(2), rts[3].region)

        @test rts[4].status == :unknown
        @test in_interval(sqrt(2), rts[4].region)

        rts = roots(g, interval(-5, 5) ; contractor)
        @test all(rt.status == :unknown for rt in rts)
        @test in_interval(0, hull([rt.region for rt in rts]...))
    end
end
@testset "Out of domain" begin
    s(x) = sqrt(x^2 - 4) - 2  # root: -6 and 6
    a(xy) = [asin(xy[1]), acos(xy[2]) - π/2]  # root: (0, 0)

    for contractor in newtonlike_methods
        @suppress @test length(roots(log, interval(-100, 2) ; contractor)) == 1
        @suppress @test length(roots(log, interval(-100, -1) ; contractor)) == 0

        @suppress @test length(roots(s, interval(-20, 20) ; contractor)) == 2
        @suppress @test length(roots(s, interval(0, 20) ; contractor)) == 1
        @suppress @test length(roots(s, interval(-1, 1) ; contractor))  == 0

        @suppress @test length(roots(a, fill(interval(-20, 20), 2) ; contractor)) == 1
        @suppress @test length(roots(a, fill(interval(0.5, 20), 2) ; contractor)) == 0
    end
end

@testset "Infinite domain" begin
    # Infinite interval
    f(xy) = [sin(1/xy[1]), xy[1]*xy[2]]  # largest roots: [1/π, 0] and [infinity, 0]

    for contractor in newtonlike_methods
        rts = @suppress roots(x -> x^2 - 2, interval(-Inf, Inf) ; contractor)
        @test length(rts) == 2
        @test all(isbounded, [rt.region for rt in rts])
        @test all(rt.region.decoration == dac for rt in rts)
        @test all(isunique, rts)

        rts = @suppress roots(f, [interval(0.9/π, Inf), interval(-Inf, Inf)] ; contractor)
        @test length(rts) == 2
        sort!(rts, by = mig)
        @test isunique(rts[1])
        @test all(isbounded, rts[1].region)
        @test minimum(X.decoration for X in rts[1].region) == dac

        @test !isunique(rts[2])
        @test !all(isbounded, rts[2].region)
        @test minimum(X.decoration for X in rts[2].region) == dac
    end
end

@testset "NaN return value" begin
    f1(x) = x^2/x - 1
    f(xy) = [log(xy[2]/xy[1]) + 3xy[1], xy[2] - 2xy[1]]
    X = [interval(-100, 100), interval(-100, 100)]

    for contractor in newtonlike_methods
        rts = roots(f1, interval(-2, 2) ; contractor)
        @test length(rts) == 2
        @test !isunique(rts[1])
        @test in_interval(0, root_region(rts[1]))
        @test isunique(rts[2])

        rts = roots(f, X ; contractor)
        @test length(filter(isunique, rts)) == 1
        @test length(filter(x -> all(in_interval.(0, x)), root_region.(rts))) == 1
    end
end

@testset "Root at infinity" begin
    for contractor in newtonlike_methods
        pb = RootProblem(x -> 1/x, interval(1, Inf) ; contractor)

        state = nothing
        for (k, s) in enumerate(pb)
            state = s
            
            k > 1000 && break
        end

        rts = [leaf.region for leaf in BranchAndPrune.Leaves(state.tree)]
        for rt in rts
            # Some roots have an empty trivial interval for unknown reason,
            # which is unhelpful but not incorrect
            if decoration(rt.region) != trv
                @test sup(rt.region) == Inf
            end
        end
    end
end

@testset "Complex roots" begin
    X = interval(-5, 5)
    Xc = Complex(X, X)
    f(z) = z^3 - 1
    df(z) = 3z^2

    # Default
    for contractor in newtonlike_methods
        rts = roots(f, Xc ; derivative = df, contractor, abstol = 1e-3)
        @test count(isunique, rts) == 3
    end

    # Bisection
    rts = roots(f, Xc ; contractor = Bisection, abstol = 1e-3)
end

@testset "@exact" begin
    @testset "1D" begin
        @exact f(x) = x^2 - 2.25
        @exact g(x) = sin(1.57x)

        f0(x) = x^2 - 2.25
        g0(x) = sin(1.57x)

        X = interval(-2.2, 2.2)

        @testset for method in newtonlike_methods
            for (func, func0, nsol) in [(f, f0, 2), (g, g0, 3)]
                rts = roots(func, X ; contractor = method)
                @test length(rts) == nsol

                rts0 = roots(func0, X ; contractor = method)
                for (rt, rt0) in zip(rts, rts0)
                    @test isequal_interval(root_region(rt), root_region(rt0))
                end

                @test all(isguaranteed.(root_region.(rts)))
            end
        end
    end

    @testset "2D" begin
        @exact f(xx) = [xx[1]^2 - 1, xx[2]^2 - 5]
        X = [interval(-2, 2), interval(-10, 10)]
        @testset for method in newtonlike_methods
            rts = roots(f, X ; contractor = method)
            @test all(rts) do rt
                all(isguaranteed.(root_region(rt)))
            end
        end
    end
end

function f_vec(X)
    x, y = X
    return [x^2 - 2, y^2 - 2]
end

function df_vec(X)
    x, y = X
    return [2x 0.0 ; 0.0 2y]
end

function f_svec(X)
    x, y = X
    return SVector(x^2 - 2, y^2 - 2)
end

function df_svec(X)
    x, y = X
    return SMatrix{2, 2}(2x, 0.0, 0.0, 2y)
end

@testset "Type stability" begin
    f(x) = x^2 - 2
    df(x) = 2x

    X = interval(0, 5)
    x = Root(X, :unknown)
    x_vec = Root([X, X], :unknown)
    x_svec = Root(SVector(X, X), :unknown)

    for contractor in newtonlike_methods
        @testset "$contractor" begin
            @inferred roots(f, x ; contractor)
            @inferred roots(f, x ; contractor, derivative = df)

            rts_vec1 = @inferred roots(f_vec, x_vec ; contractor)
            rts_vec2 = @inferred roots(f_vec, x_vec ; contractor, derivative = df_vec)
            @test eltype(rts_vec1) <: Root{<:Vector}
            @test eltype(rts_vec2) <: Root{<:Vector}

            rts_svec1 = @inferred roots(f_svec, x_svec ; contractor)
            rts_svec2 = @inferred roots(f_svec, x_svec ; contractor, derivative = df_svec)
            @test eltype(rts_svec1) <: Root{<:SVector}
            @test eltype(rts_svec2) <: Root{<:SVector}

            # Check that the root type is determined by the return type of the function
            @test eltype(roots(f_vec, SVector(X, X) ; contractor)) <: Root{<:Vector}
            @test eltype(roots(f_svec, [X, X] ; contractor)) <: Root{<:SVector}
        end
    end
end

@testset "Stop criteria" begin
    abstols = [1e-4, 1e-7, 1e-10]
    reltols = [1e-4, 1e-7, 1e-10]

    f(x) = x*sin(1/x)

    for abstol in abstols
        for reltol in reltols
            rts = roots(f, interval(0, 1) ; abstol, reltol, max_iteration = typemax(Int))
            regions = [rt.region for rt in rts if root_status(rt) == :unknown]

            @test all(
                (diam.(regions) .< abstol) .|
                (diam.(regions) .< (reltol .* mag.(regions)))
            )
        end
    end

    for max_iteration in [10, 100, 1000, 10_000]
        rts = roots(f, interval(0, 1) ; abstol = 1e-10, max_iteration)
        @test length(rts) <= max_iteration
    end
end

# straightforward method for unpacking the elements of a root.
function unpacking(r::Root{T}) where T
    return (r.region, r.status)
end

@testset "Unpacking roots" begin
    @testset "1D" begin
        g(x) = cos(x) * sin(1 / x)

        for r in roots(g, interval(0.05, 1))
            x, status = r
            @test isa(x, Interval)
            @test isa(status, Symbol)

            # unpack using the straightforward method. 
            unx, uns = unpacking(r)
            @test isequal_interval(x, unx)
            @test status == uns
        end

        # function with two roots
        f(x) = x^2 - 1
        for r in roots(f, interval(-2, 2))
            x, status = r
            @test status == :unique
        end
    end

    @testset "2D" begin
        f(x, y) = SVector(x^2 + y^2 - 1, y - 2x)
        f(X) = f(X...)
        X = SVector(interval(-6, 6), interval(-6, 6))

        for (x, status) in roots(f, X)
            @test isa(x, SVector{2, <:Interval})
            @test isa(status, Symbol)
        end
    end

    @testset "3D" begin
        h(x, y, z) = SVector(x^2 + y^2 + z^2 - 1, y - 2x, z - 2x)
        h(X) = h(X...)
        X = SVector(interval(-6, 6), interval(-6, 6), interval(-6, 6)) # cube in R^3

        myroots = []
        unroots = []

        for (x, status) in roots(h, X)
            @test isa(x, SVector{3, <:Interval})
            @test isa(status, Symbol)
            append!(myroots, x)
        end

        for (x, status) in unpacking.(roots(h, X))
            append!(unroots, x)
        end

        @test all(isequal_interval.(myroots, unroots))
    end
end

@testset "Bisect on error" begin
    f(x) = (x < 1 ? x : x^2)
    
    rts = roots(f, interval(-10, 10))
    @test length(rts) == 2
    @test rts[1].status == :unique
    @test rts[1].convergence == :converged
    @test isnothing(rts[1].error)

    @test rts[2].status == :unknown
    @test rts[2].convergence == :tolerance
    @test !isnothing(rts[2].error)
    @test rts[2].error[1] isa IntervalArithmetic.InconclusiveBooleanOperation

    @test_throws IntervalArithmetic.InconclusiveBooleanOperation roots(f, interval(-10, 10) ; ignored_errors = [])

    g(x) = (x < 1 ? x : error())
    rts = roots(g, interval(-10, 10) ; ignored_errors = [ErrorException, IntervalArithmetic.InconclusiveBooleanOperation])
    @test any(isunique, rts)
end

# Wilkinson-type polynomial defined by its roots:
# Wn(x) = (x-1)⋅(x-2)⋅ ⋯ ⋅ (x-n)
W3(x) = prod(x .- (1:3))
W7(x) = prod(x .- (1:7))

# Format:  (function, derivative, lower_bound, upper_bound, [true_roots])
function_list = [
    (sin, cos, -5,  5, [-big(π), 0, big(π)]) ,
    (cos, x -> -sin(x), -7.5, 7.5, [-3big(π)/2, -big(π)/2, big(π)/2, 3big(π)/2]),
    (W3, nothing, -10, 10, [1, 2, 3]),
    (W7, nothing, -10, 10, collect(1:7)),
    (x -> exp(x) - 2, exp, -20, 20, [log(big(2))]),
    (x -> asin(sin(x)) - big"0.1", Returns(1.0), 0, 1, [big"0.1"]),
]

@testset "Various precisions" begin
    @testset "$T" for T in [Float64, BigFloat]
        @testset "Function $(func[1])" for func in function_list
            @testset "$contractor" for contractor in newtonlike_methods
                f, f_prime, a_lower, a_upper, true_roots = func
                a = interval(T, a_lower, a_upper)

                @testset "autodiff = $autodiff" for autodiff in (false, true)
                    isnothing(f_prime) && continue

                    if autodiff
                        rts = roots(f, a ; contractor)
                    else
                        rts = roots(f, a ; contractor, derivative = f_prime)
                    end

                    @test length(rts) == length(true_roots)

                    for (root, true_root) in zip(rts, true_roots)
                        @test isa(root, Root)
                        @test isunique(root)
                        @test in_interval(true_root, root.region)
                    end
                end
            end
        end
    end
end


@testset "Interval parameters" begin
    a = interval(1.9, 2.1)
    for contractor in newtonlike_methods
        rts = roots(x -> x^2 - a^2, interval(0, 10) ; contractor)

        @test length(rts) == 1
        @test issubset_interval(a, rts[1].region)
    end
end

# API

## Main interface

```@autodocs
Modules = [IntervalRootFinding]
Pages   = ["roots.jl"]
```

## `Root` object

```@autodocs
Modules = [IntervalRootFinding]
Pages   = ["root_object.jl"]
```

## Contractors

```@autodocs
Modules = [IntervalRootFinding]
Pages   = ["contractors.jl"]
```

## Branch-and-bound search interface

```@autodocs
Modules = [IntervalRootFinding]
Pages   = ["branch_and_bound.jl"]
```

## Others

```@autodocs
Modules = [IntervalRootFinding]
Pages   = ["complex.jl", "linear_eq.jl", "newton1d.jl", "quadratic.jl", "slopes.jl"]
```

```@meta
DocTestSetup = quote
    using IntervalArithmetic, IntervalArithmetic.Symbols, IntervalRootFinding
end
```
# `roots` interface

## Methods

Three root-finding contractors currently available through the `roots` interface are the following:
  - `Newton` (default);
  - `Krawczyk`;
  - `Bisection`

Both the Newton and Krawczyk methods can determine if a root is unique in an interval, at the cost of requiring that the function is differentiable. The bisection method has no such requirement, but can never guarantee the existence or uniqueness of a root.

The method used is given using the `contractor` keyword argument:

```jldoctest
julia> roots(log, -2 .. 2 ; contractor = Newton)
1-element Vector{Root{Interval{Float64}}}:
 Root([0.999999, 1.00001]_com, :unique)

julia> roots(log, -2 .. 2 ; contractor = Krawczyk)
1-element Vector{Root{Interval{Float64}}}:
 Root([0.999999, 1.00001]_com, :unique)

julia> roots(log, -2 .. 2 ; contractor = Bisection)
1-element Vector{Root{Interval{Float64}}}:
 Root([0.999999, 1.00001]_com, :unknown)
 └ Not converged: region size smaller than the tolerance
```

Note that as shown in the example, the `log` function does not complain about being given an interval going outside its domain. While this may be surprising, this is the expected behavior and no root will ever be found outside the domain of a function.

## Explicit derivatives

Newton and Krawczyk methods require the function to be differentiable, but the derivative is usually computed automatically using forward-mode automatic differentiation, provided by the `ForwardDiff.jl` package. It is however possible to provide the derivative explicitly using the `derivative` keyword argument:

```jldoctest
julia> roots(log, -2 .. 2 ; contractor = Newton, derivative = x -> 1/x)
1-element Vector{Root{Interval{Float64}}}:
 Root([0.999999, 1.00001]_com_NG, :unique)

julia> roots(log, -2 .. 2 ; contractor = Krawczyk, derivative = x -> 1/x)
1-element Vector{Root{Interval{Float64}}}:
 Root([0.999999, 1.00001]_com_NG, :unique)
```

When providing the derivative explicitly, the computation is expected to be slightly faster, but the precision of the result is unlikely to be affected.

```julia-repl
julia> using BenchmarkTools

julia> @btime roots(log, -2 .. 2 ; derivative = x -> 1/x)
  7.050 μs (129 allocations: 9.33 KiB)
1-element Vector{Root{Interval{Float64}}}:
 Root([1.0, 1.0]_com_NG, :unique)

julia> @btime roots(log, -2 .. 2)
  7.743 μs (129 allocations: 9.33 KiB)
1-element Vector{Root{Interval{Float64}}}:
 Root([1.0, 1.0]_com, :unique)
```

This may be useful in some special cases where `ForwardDiff.jl` is unable to compute the derivative of a function. Examples are complex functions and functions whose interval extension must be manually defined (e.g. special functions like `zeta`).

In dimension greater than one, the derivative can be given as a function returning the Jacobi matrix:

```jldoctest
julia> f( (x, y) ) = [sin(x), cos(y)]
f (generic function with 1 method)

julia> df( (x, y) ) = [cos(x) 0 ; 0 -sin(y)]
df (generic function with 1 method)

julia> roots(f, [-3 .. 3, -3 .. 3] ; derivative = df)
2-element Vector{Root{Vector{Interval{Float64}}}}:
 Root(Interval{Float64}[[-3.93242e-20, 3.93242e-20]_com_NG, [-1.5708, -1.57079]_com_NG], :unique)
 Root(Interval{Float64}[[-3.93242e-20, 3.93242e-20]_com_NG, [1.57079, 1.5708]_com_NG], :unique)
```

## Tolerance

An absolute tolerance for the search may be specified as the `abstol` keyword argument.

```jldoctest
julia> g(x) = sin(exp(x))
g (generic function with 1 method)

julia> roots(g, 0 .. 2)
2-element Vector{Root{Interval{Float64}}}:
 Root([1.14472, 1.14473]_com, :unique)
 Root([1.83787, 1.83788]_com, :unique)

julia> roots(g, 0 .. 2 ; abstol = 1e-1)
2-element Vector{Root{Interval{Float64}}}:
 Root([1.12049, 1.16994]_com, :unique)
 Root([1.82369, 1.85206]_com, :unique)
```

A lower tolerance may greatly reduce the computation time, at the cost of an increased number of returned roots having `:unknown` status:

```julia-repl
julia> h(x) = cos(x) * sin(1 / x)
h (generic function with 1 method)

julia> @btime roots(h, 0.05 .. 1)
  484.488 μs (12218 allocations: 590.76 KiB)
6-element Vector{Root{Interval{Float64}}}:
 Root([0.0530516, 0.0530517]_com_NG, :unique)
 Root([0.063662, 0.063662]_com_NG, :unique)
 Root([0.0795775, 0.0795775]_com_NG, :unique)
 Root([0.106103, 0.106103]_com_NG, :unique)
 Root([0.159155, 0.159155]_com_NG, :unique)
 Root([0.31831, 0.31831]_com_NG, :unique)

julia> @btime roots(h, 0.05 .. 1 ; abstol = 1e-2)
  249.720 μs (6141 allocations: 297.80 KiB)
6-element Vector{Root{Interval{Float64}}}:
 Root([0.0514446, 0.0531086]_com_NG, :unique)
 Root([0.0570254, 0.0641614]_com, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.0785458, 0.0797797]_com_NG, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.104755, 0.107541]_com_NG, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.157236, 0.165988]_com_NG, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.317161, 0.319318]_com_NG, :unique)

julia> @btime roots(h, 0.05 .. 1 ; abstol = 1e-1)
  66.330 μs (1402 allocations: 69.10 KiB)
3-element Vector{Root{Interval{Float64}}}:
 Root([0.05, 0.107541]_com, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.107541, 0.165988]_com, :unknown)
    Not converged: region size smaller than the tolerance
 Root([0.283804, 0.356099]_com_NG, :unknown)
    Not converged: region size smaller than the tolerance
```

The last example shows a case where the tolerance was too large to be able to isolate the roots in distinct regions.

!!! warning

    For a root `x` of some function, if the absolute tolerance is smaller than `eps(x)` i.e. if `tol + x == x`, `roots` may never be able to converge to the required tolerance and the function may get stuck in an infinite loop.
    To avoid that, either increase `abstol` or `reltol`,
    or set a maximum number of iterations with the `max_iteration` keyword.

## Error during computation

By default, the `roots` function will ignore `IntervalArithmetic.InconclusiveBooleanOperation`
errors and continue bisecting the given interval,
hoping to eventually find regions that are small enough to avoid the error.

This is useful when using code that is using comparisons,
which are ill-defined for intervals
(see [the IntervalArithmetic.jl documentation](https://juliaintervals.github.io/IntervalArithmetic.jl/stable/manual/usage/#Comparisons)
for more information).

For example, the following will find all roots,
and flag the erroring singularity:
```jldoctest bisect_on_error
julia> f(x) = x > 2 ? 7 - x : x
f (generic function with 1 method)

julia> roots(f, -10 .. 10)
3-element Vector{Root{Interval{Float64}}}:
 Root([0.0, 0.0]_com, :unique)
 Root([1.99999, 2.00001]_com, :unknown)
 ├ Not converged: region size smaller than the tolerance
 ├ Warning: error encountered during computation (use showerror(root.error) to see the whole stacktrace)
 └ InconclusiveBooleanOperation: The operation `[2.0, 2.0]_com_NG < [1.99999, 2.00001]_com` cannot be determined unambiguously. See the documentation for more information. See also `strictprecedes`.
 Root([7.0, 7.0]_com_NG, :unique)
```

This behavior can be controlled by changing the `ignored_errors` field.

To deactivate it, change it to an empty list,
so that the process is interrupted as soon as an error is encountered.
This is useful while debugging your code.

```julia-repl
julia> roots(f, -10 .. 10, ; ignored_errors = [])
ERROR: InconclusiveBooleanOperation: The operation `[2.0, 2.0]_com_NG < [-10.0, 10.0]_com` cannot be determined unambiguously. See the documentation for more information. See also `strictprecedes`.
Stacktrace: [..]
```

# Test suites:

- <http://folk.uib.no/ssu029/Pdf_file/Testproblems/testprobRheinboldt03.pdf>

- <http://www.mat.univie.ac.at/~neum/glopt/test.html>

- <http://titan.princeton.edu/TestProblems/>

- <http://www-sop.inria.fr/saga/POL/>

- MINPACK benchmarks: <https://github.com/JuliaNLSolvers/NLsolve.jl/blob/master/test/minpack.jl>

 and other files in NLsolve test suite


# Papers

- Testing unconstrained optimization software, Moré, Garbow, Hillstrom ACM Trans. Math. Soft. 7 (1), 17-41 (1981)

```@meta
DocTestSetup = quote
    using IntervalArithmetic, IntervalArithmetic.Symbols, IntervalRootFinding
end
```
# Internals

This section describes some of the internal mechanism of the package and several ways to use them to customize a search.

## Branch and bound

When `roots` is called, it performs a **branch-and-bound** search, that is, it iteratively looks at a region $X$ and for each region tries to determine if it contains a root. It then does the following:
  - If $X$ is proven to contain *no* root, it discards it.
  - If $X$ is proven to contain *exactly one root*, it tries to get the best possible bounds for the root and store the resulting region in the list of `Root`s to output with a `:unique` status.
  - If the test is inconclusive and the size of $X$ is smaller than the tolerance, it stores it in the list of `Root`s to output with `:unknown` status.
  - If the test is inconclusive and the size of $X$ is larger than the tolerance, it bisects $X$ and then processes each resulting half.

At some point all regions will either have a determined status or be smaller than the tolerance, and the algorithm will halt and return all stored roots.

## Contractors

To determine the status of a region, the algorithm uses so-called *contractors*.
When we contract a region (wrapped in a `Root` object),
it returns the status of the root and the region.
The contractors are various methods to guarantee and refine the
status of a root.
The available contractors are `Bisection`, `Newton` or `Krawczyk`.

```jldoctest
julia> using IntervalRootFinding: contract

julia> contract(Newton, sin, cos, Root(pi ± 0.001, :unknown))
Root([3.14159, 3.1416]_com, :unique)

julia> contract(Newton, sin, cos, Root(2 ± 0.001, :unknown))
Root([1.999, 2.00101]_com, :empty)
```

While it is the fastest and doesn't require derivatives,
`Bisection` can never prove the existence or unicity of a root.

## Tree representation

A branch-and-bound search can be naturally represented as a binary tree: each leaf contains a region and its status and each node represents a bisection. If the tree is known, the topology of the whole search can be reconstructed. There is however a point not determined by the tree.

The branch and bound algorithm used by the `roots` function builds this tree
and at the end collect all leaves containing a region with status either `:unknown` or `:unique`.

## Search strategy

While the tree representation is sufficient to know the topology of the search,
it does not determine the order in which leaves are processed during the search.
This has an influence on how the tree is created and the amount of memory used,
but will not change the resulting tree,
unless the maximal number of iterations is reached.

Two strategies are currently available: a breadth-first strategy (process all regions before processing a sub-region);
and a depth-first strategy (immediately process the sub-regions of the last processed region).

Usually, the breadth-first strategy (default) is preferred,
as the depth-first strategy may get "stuck" on a single point with a singularity,
until either the tolerance or the maximum number of iterations is reached.

## RootProblem and search object

The parameters of a search are represented by a `RootProblem` object
that has the same signature as the `roots` function.

The `RootProblem` can be iterated to perform the search of the roots,
to log information, introduce an early stop criterion,
or even modify the iteration state.

The follow example stops the search after 15 iterations and
shows the state of the search at that point.

```jldoctest
julia> f(x) = exp(x) - sin(x)
f (generic function with 1 method)

julia> problem = RootProblem(f, interval(-10, 10))
RootProblem
  Contractor: Krawczyk
  Function: f
  Search region: [-10.0, 10.0]_com
  Search order: BreadthFirst
  Absolute tolerance: 1.0e-7
  Relative tolerance: 0.0
  Maximum iterations: 100000
  Ignored errors: DataType[IntervalArithmetic.InconclusiveBooleanOperation]

julia> state = nothing   # stores current state of the search, so that it will be available outside of the loop

julia> for s in problem
           global state = s
           state.iteration == 15 && break
       end

julia> state
SearchState{BreadthFirst{Root{Interval{Float64}}}, Root{Interval{Float64}}}
  iteration: 15
  5 regions being processed
    Root([-0.078125, 1.15235]_com, :unknown)
 └ Not converged: the root is still being processed
    Root([-3.84735, -2.5975]_com, :unknown)
 └ Not converged: the root is still being processed
    Root([-5.07782, -3.84734]_com, :unknown)
 └ Not converged: the root is still being processed
    Root([-8.78861, -7.55813]_com, :unknown)
 └ Not converged: the root is still being processed
    Root([-10.0, -8.7886]_com, :unknown)
 └ Not converged: the root is still being processed
  1 finalized regions
    Root([-6.28132, -6.28131]_com, :unique)

```

The elements of the iteration are `SearchState` from the `BranchAndPrune.jl` package.

The roots being processed can be accessed with `unfinished_roots(state)`
and the finalized one with `finished_roots(state)`,
while `roots(state)` return a list containing both.

See `examples/closest_to_zero.jl` for a more advanced example,
which shows how you can find the root that is closest to zero
and immediately terminate the search.

```@meta
DocTestSetup = quote
    using IntervalArithmetic, IntervalArithmetic.Symbols, IntervalRootFinding, StaticArrays
end
```
# `IntervalRootFinding.jl`

This package provides guaranteed methods for finding **roots** of functions $f: \mathbb{R}^n \to \mathbb{R}^n$ with $n \ge 1$, i.e. vectors (or scalars, for $n=1$) $\mathbb{x}$ for which $f(\mathbb{x}) = \mathbb{0}$. In principle, it guarantees to find *all* roots inside a given box in $\mathbb{R}^n$, or report subboxes for which it is unable to provide guarantees.

To do so, it uses methods from interval analysis, using interval arithmetic from the [`IntervalArithmetic.jl`](https://github.com/JuliaIntervals/IntervalArithmetic.jl) package by the same authors.

!!! warning

    While this package aimed at providing *guaranteed results* and despite our best efforts and test suite, some bugs may remain and there are several known issues with corner cases. Please look at the [issue tracker](https://github.com/JuliaIntervals/IntervalRootFinding.jl/issues) and report there any odd and/or incorrect behavior.

## Basic 1D example

To begin, we need a standard Julia function and an interval in which to search roots of that function. Intervals use the `Interval` type provided by the `IntervalArithmetic.jl` package
Intervals are generally constructed using the `..` syntax (from the `IntervalArithmetic.Symbols` submodule),
`a .. b` representing the closed interval $[a, b]$.

When provided with this information, the `roots` function will return a vector of all roots of the function in the given interval.

Example:

```jldoctest
julia> using IntervalArithmetic, IntervalArithmetic.Symbols, IntervalRootFinding

julia> rts = roots(x -> x^2 - 2x, 0 .. 10)
2-element Vector{Root{Interval{Float64}}}:
 Root([0.0, 3.73951e-8]_com_NG, :unknown)
 └ Not converged: region size smaller than the tolerance
 Root([1.99999, 2.00001]_com_NG, :unique)
```

The roots are returned as `Root` objects, containing an interval and the status of that interval, represented as a `Symbol`. There are two possible types of root status, as shown in the example:
  - `:unique`: the given interval contains *exactly one* root of the function,
  - `:unknown`: the given interval may or may not contain one or more roots; the algorithm used was unable to come to a conclusion.
  In this case, additional information is stored in the root,
  describing why the interval was not further bisected.

The second status is still informative, since all regions of the original search interval *not* contained in *any* of the returned root intervals is guaranteed *not* to contain any root of the function. In the above example, we know that the function has no root in the interval $[2.1, 10]$, for example.

Most of the time, a root has status unknown because the convergence
limits have been reached.
This information is stored in the `convergence` field of the root,
and can be either of
  - `:max_iterartion`: the maximal number of iteration was reached
  (`max_iteration` keyword);
  - `:tolerance`: the interval is smaller than the specified
  tolerance (`abstol` and `reltol` keywords,
  for absolute and relative tolerance respectively).

However, there are several known situations where the uniqueness
(and existence) of a solution can never be determined
by the interval algorithms used in the package:
  - If the function errors for specific intervals
    (for example if comparison operators like `==` and `<` are used);
  - If the solution is on the boundary of the interval (as in the previous example);
  - If the derivative of the solution is zero at the solution.

The latest case happens for example when the function
has multiple degenerate root,
and then the unicity of the solution cannot be established.
For example:

```jldoctest
julia> g(x) = (x^2 - 2)^2 * (x^2 - 3)
g (generic function with 1 method)

julia> roots(g, -10 .. 10)
4-element Vector{Root{Interval{Float64}}}:
 Root([-1.73206, -1.73205]_com_NG, :unique)
 Root([-1.41422, -1.41421]_com_NG, :unknown)
 └ Not converged: region size smaller than the tolerance
 Root([1.41421, 1.41422]_com_NG, :unknown)
 └ Not converged: region size smaller than the tolerance
 Root([1.73205, 1.73206]_com_NG, :unique)
```

Here we see that the two double roots are reported as being possible roots without guarantee and the simple roots have been proved to be unique.


## Basic multi-dimensional example

For dimensions $n > 1$, the function passed to `roots` must take an array as
argument and return an array.
The initial search region is an array of interval.

Here we give a 3D example:

```jldoctest
julia> function g( (x1, x2, x3) )
          return [
              x1^2 + x2^2 + x3^2 - 1,
              x1^2 + x3^2 - 0.25,
              x1^2 + x2^2 - 4x3
          ]
       end
g (generic function with 1 method)

julia> X = -5 .. 5
[-5.0, 5.0]_com

julia> rts = roots(g, [X, X, X])
4-element Vector{Root{Vector{Interval{Float64}}}}:
 Root(Interval{Float64}[[-0.440763, -0.440762]_com_NG, [-0.866026, -0.866025]_com_NG, [0.236067, 0.236068]_com_NG], :unique)
 Root(Interval{Float64}[[-0.440763, -0.440762]_com_NG, [0.866025, 0.866026]_com_NG, [0.236067, 0.236068]_com_NG], :unique)
 Root(Interval{Float64}[[0.440762, 0.440763]_com_NG, [-0.866026, -0.866025]_com_NG, [0.236067, 0.236068]_com_NG], :unique)
 Root(Interval{Float64}[[0.440762, 0.440763]_com_NG, [0.866025, 0.866026]_com_NG, [0.236067, 0.236068]_com_NG], :unique)
```

Thus, the system admits four unique roots in the box $[-5, 5]^3$.

Moreover, the package is compatible with `StaticArrays.jl`.
Usage of static arrays is recommended to increase performance.
```jldoctest
julia> using StaticArrays

julia> h((x, y)) = SVector(x^2 - 4, y^2 - 16)
h (generic function with 1 method)

julia> X = -5 .. 5
[-5.0, 5.0]_com

julia> roots(h, SVector(X, X))
4-element Vector{Root{SVector{2, Interval{Float64}}}}:
 Root(Interval{Float64}[[-2.00001, -1.99999]_com_NG, [-4.00001, -3.99999]_com_NG], :unique)
 Root(Interval{Float64}[[-2.00001, -1.99999]_com_NG, [3.99999, 4.00001]_com_NG], :unique)
 Root(Interval{Float64}[[1.99999, 2.00001]_com_NG, [-4.00001, -3.99999]_com_NG], :unique)
 Root(Interval{Float64}[[1.99999, 2.00001]_com_NG, [3.99999, 4.00001]_com_NG], :unique)
```

### Vector types

The multidimensional search region (formerly represented as `IntervalBox`)
can be represented by both `Vector` and `SVector` (from `StaticArrays.jl`)
of `Interval`,
the latter giving better performances.

However, the types used must be consistent:
when using `roots(f, X)`, `f(X)` should have the same type as `X`.
In particular, if `f` return a `SVector` of `Interval`,
make sure to use a `SVector` of `Interval` for the initial search region `X`.

Moreover, if `X` and `f(X)` are `SVector`, and the jacobian function
is given explicitly,
then the jacobian function should return a `SMatrix` of the appropriate size.

Mixing between (standard) `Vector` and (static) `SVector`
may result in errors or bad performances.

Note that the function doesn't need to be defined specifically for `Interval` inputs:
for example `f(X) = [X[1]^2 - 2, X[2]^2 - 3]`
returns either a `Vector{Float64}` or a `Vector{Interval}` depending
on the input.

Furthermore, when you know that the number given as literals are parsed exactly
(which is typically not guaranteed for floating points inputs),
you can avoid the `NG` flag that arise from mixing numbers and intervals,
with the `@exact` macro:
```jldoctest exact-2
julia> f(X) = @exact [X[1]^2 - 2, X[2]^2 - 3]
f (generic function with 1 method)

julia> x = [interval(0, 5), interval(0, 5)]
2-element Vector{Interval{Float64}}:
 [0.0, 5.0]_com
 [0.0, 5.0]_com

julia> roots(f, x)
1-element Vector{Root{Vector{Interval{Float64}}}}:
 Root(Interval{Float64}[[1.41421, 1.41422]_com, [1.73205, 1.73206]_com], :unique)
```
This macro does not disturb the function when called with non-interval inputs:
```jldoctest exact-2
julia> f([1.2, 2.2])
2-element Vector{Float64}:
 -0.56
  1.8400000000000007
```

### Stationary points

Stationary points of a function $f:\mathbb{R}^n \to \mathbb{R}$ may be found as zeros of the gradient of $f$.
The gradient can be computed using `ForwardDiff.jl`:

```julia-repl
julia> using ForwardDiff: gradient

julia> f( (x, y) ) = sin(x) * sin(y)
f (generic function with 1 method)

julia> ∇f(x) = gradient(f, x)  # gradient operator from the package
∇f (generic function with 1 method)

julia> rts = roots(∇f, SVector(interval(-5, 6), interval(-5, 6)) ; abstol = 1e-5)
25-element Vector{Root{SVector{2, Interval{Float64}}}}:
 Root(Interval{Float64}[[-4.71239, -4.71239]_com, [-4.71239, -4.71239]_com], :unique)
 Root(Interval{Float64}[[-3.14159, -3.14159]_com, [-3.14159, -3.14159]_com], :unique)
 Root(Interval{Float64}[[-4.71239, -4.71239]_com, [-1.5708, -1.5708]_com], :unique)
 Root(Interval{Float64}[[-3.14159, -3.14159]_com, [-3.88602e-10, 6.62844e-11]_com], :unique)
 Root(Interval{Float64}[[-1.5708, -1.5708]_com, [-4.71239, -4.71239]_com], :unique)
 Root(Interval{Float64}[[-3.74621e-10, 7.17246e-11]_com, [-3.14159, -3.14159]_com], :unique)
 Root(Interval{Float64}[[-1.5708, -1.5708]_com, [-1.5708, -1.5708]_com], :unique)
 Root(Interval{Float64}[[-6.04841e-12, 1.04386e-12]_com, [-6.04841e-12, 1.03449e-12]_com], :unique)
 Root(Interval{Float64}[[-4.71239, -4.71239]_com, [1.5708, 1.5708]_com], :unique)
 Root(Interval{Float64}[[-3.14159, -3.14159]_com, [3.14159, 3.14159]_com], :unique)
 Root(Interval{Float64}[[-1.5708, -1.5708]_com, [1.5708, 1.5708]_com], :unique)
 Root(Interval{Float64}[[-1.69679e-6, 3.8872e-7]_com, [3.14159, 3.14159]_com], :unique)
 Root(Interval{Float64}[[-4.71239, -4.71239]_com, [4.71239, 4.71239]_com], :unique)
 Root(Interval{Float64}[[-1.5708, -1.57079]_com, [4.71239, 4.71239]_com], :unique)
 Root(Interval{Float64}[[1.5708, 1.5708]_com, [-4.71239, -4.71239]_com], :unique)
 Root(Interval{Float64}[[3.14159, 3.14159]_com, [-3.14159, -3.14159]_com], :unique)
 Root(Interval{Float64}[[1.5708, 1.5708]_com, [-1.5708, -1.5708]_com], :unique)
 Root(Interval{Float64}[[3.14159, 3.14159]_com, [-3.5929e-14, 5.92849e-15]_com], :unique)
 Root(Interval{Float64}[[4.71239, 4.71239]_com, [-4.71239, -4.71239]_com], :unique)
 Root(Interval{Float64}[[4.71239, 4.71239]_com, [-1.5708, -1.57079]_com], :unique)
 Root(Interval{Float64}[[1.5708, 1.5708]_com, [1.5708, 1.5708]_com], :unique)
 Root(Interval{Float64}[[3.14159, 3.14159]_com, [3.14159, 3.14159]_com], :unique)
 Root(Interval{Float64}[[1.57079, 1.5708]_com, [4.71239, 4.71239]_com], :unique)
 Root(Interval{Float64}[[4.71239, 4.71239]_com, [1.57079, 1.5708]_com], :unique)
 Root(Interval{Float64}[[4.71239, 4.71239]_com, [4.71239, 4.71239]_com], :unique)
```

Now let's find the midpoints and plot them:

```julia
midpoints = [mid.(root_region(rt)) for rt in rts]

xs = first.(midpoints)
ys = last.(midpoints)

using Plots; plotlyjs()

surface(-5:0.1:6, -6:0.1:6, (x,y) -> f([x, y]))
scatter!(xs, ys, f.(midpoints))
```

![stationary points](stationary_points.png)

```@meta
DocTestSetup = quote
    using IntervalRootFinding
end
```
# Decorations and guarantees

When you define a simple function, you will notice that the roots
usually come out with the flag `com` and `NG`.

```jldoctest
julia> roots(x -> x^2 - 0.1, interval(-5, 5))
2-element Vector{Root{Interval{Float64}}}:
 Root([-0.316228, -0.316227]_com_NG, :unique)
 Root([0.316227, 0.316228]_com_NG, :unique)
```

In this case, `com` is the *decoration* of the interval,
and `NG` its *guarantee*.
See the documentation of `IntervalArithmetic.jl` for a detailed description,
here we will go on what they mean in the context of finding roots
of a function.

## Decorations

The decoration tells us whether all operations that affected the interval
were well-behaved.
The two crucial ones for us are `def` (the operations were not continuous)
and `trv` (something horribly wrong happened).

In both cases, it means that the root can not be trusted,
as the hypothesis of the theory we use are not fulfilled.

## Guarantee

The `NG` flags means that non-interval have been mixed with intervals.
Since we can not track the source of the non-interval numbers,
we can not guarantee that they are correct.
For example, `0.1` is famously not parsed as `0.1`,
as `0.1` can not be represented exactly as a binary number
(just like `1/3` can not be represented exactly as a decimal number).

```jldoctest
julia> big(0.1)
0.1000000000000000055511151231257827021181583404541015625
```

If you want the number that you are inputting to be trusted **as is**,
you can use the `@exact` macro from `IntervalArithmetic.jl`,
and the `NG` flag will be avoided in most cases.

```jldoctest exact
julia> @exact f(x) = x^2 - 0.1
f (generic function with 1 method)

julia> roots(f, interval(-5, 5))
2-element Vector{Root{Interval{Float64}}}:
 Root([-0.316228, -0.316227]_com, :unique)
 Root([0.316227, 0.316228]_com, :unique)
```

The `NG` flag can still appear if other computations,
from a library using non-interval "magic" numbers for example,
thus indicating that some non-trusted numbers have been used in the computation.

Moreover, the macro work in such a way that you can still use the defined
function with numbers and get floating point results.

```jldoctest exact
julia> f(0.2)
-0.06
```
## Trust

We are doing our best to really give validated and guaranteed results.
However, in the case that you may make your house explode based on a result
returned by this package,
we would like to remind you that you should not trust the package beyond
the promises of the license:

> THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED

All bug reports and pull requests to fix them are however more than welcome.
